diff -aruN --binary 22/administrator/components/com_content/controller.php 23/administrator/components/com_content/controller.php
--- 22/administrator/components/com_content/controller.php	2010-07-18 04:15:44.000000000 +0200
+++ 23/administrator/components/com_content/controller.php	2011-04-04 00:16:32.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: controller.php 18162 2010-07-16 07:00:47Z ian $
+ * @version		$Id: controller.php 21065 2011-04-03 22:16:32Z dextercowley $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -187,8 +187,8 @@
 				' LEFT JOIN #__users AS u ON u.id = c.created_by' .
 				' WHERE c.state <> -1' .
 				' AND c.state <> -2' .
-				' GROUP BY u.name' .
-				' ORDER BY u.name';
+				' GROUP BY u.id' .
+				' ORDER BY u.name, u.id';
 		$authors[] = JHTML::_('select.option', '0', '- '.JText::_('Select Author').' -', 'created_by', 'name');
 		$db->setQuery($query);
 		$authors = array_merge($authors, $db->loadObjectList());
diff -aruN --binary 22/administrator/components/com_menus/classes/ilink.php 23/administrator/components/com_menus/classes/ilink.php
--- 22/administrator/components/com_menus/classes/ilink.php	2010-07-18 04:15:44.000000000 +0200
+++ 23/administrator/components/com_menus/classes/ilink.php	2011-04-04 00:21:04.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: ilink.php 18162 2010-07-16 07:00:47Z ian $
+ * @version		$Id: ilink.php 21067 2011-04-03 22:21:04Z dextercowley $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -221,9 +221,7 @@
 					if ($data) {
 						if ($data->attributes('hidden') != 'true') {
 							$m = $data->getElementByPath('message');
-							if ($m) {
-								$message = $m->data();
-							}
+							$message = ($m) ? $m->data() : '';
 							unset($node);
 							$node = new iLinkNode($data->attributes('title'), $url, $message);
 							$this->addChild($node);
diff -aruN --binary 22/administrator/components/com_templates/controller.php 23/administrator/components/com_templates/controller.php
--- 22/administrator/components/com_templates/controller.php	2010-10-29 19:57:44.000000000 +0200
+++ 23/administrator/components/com_templates/controller.php	2011-03-31 17:58:18.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: controller.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: controller.php 21042 2011-03-31 15:58:17Z dextercowley $
  * @package		Joomla
  * @subpackage	Templates
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -224,7 +224,7 @@
 			$return = JFile::write($file, $txt);
 
 			// Try to make the params file unwriteable
-			if (!$ftp['enabled'] && JPath::isOwner($file) && !JPath::setPermissions($file, '0555')) {
+			if (!$ftp['enabled'] && JPath::isOwner($file) && !JPath::setPermissions($file, '0644')) {
 				JError::raiseNotice('SOME_ERROR_CODE', JText::_('Could not make the template parameter file unwritable'));
 			}
 
@@ -352,7 +352,7 @@
 		$return = JFile::write($file, $filecontent);
 
 		// Try to make the template file unwriteable
-		if (!$ftp['enabled'] && !JPath::setPermissions($file, '0555')) {
+		if (!$ftp['enabled'] && !JPath::setPermissions($file, '0644')) {
 			JError::raiseNotice('SOME_ERROR_CODE', JText::_('Could not make the template file unwritable'));
 		}
 
@@ -474,7 +474,7 @@
 		$return = JFile::write($file, $filecontent);
 
 		// Try to make the css file unwriteable
-		if (!$ftp['enabled'] && JPath::isOwner($file) && !JPath::setPermissions($file, '0555')) {
+		if (!$ftp['enabled'] && JPath::isOwner($file) && !JPath::setPermissions($file, '0644')) {
 			JError::raiseNotice('SOME_ERROR_CODE', JText::_('Could not make the css file unwritable'));
 		}
 
diff -aruN --binary 22/CHANGELOG.php 23/CHANGELOG.php
--- 22/CHANGELOG.php	2010-11-03 16:00:56.000000000 +0100
+++ 23/CHANGELOG.php	2011-04-05 00:01:18.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: CHANGELOG.php 19340 2010-11-03 15:00:55Z ian $
+* @version		$Id: CHANGELOG.php 21080 2011-04-04 22:01:17Z dextercowley $
 * @package		Joomla
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
@@ -36,6 +36,30 @@
 - -> Removed
 ! -> Note
 
+-------------------- 1.5.23 Stable Release [04-March-2011] ------------------
+
+04-Apr-2011 Mark Dexter
+ # [#25450] Mootools 1.2.4 Squeezebox Problems in MSIE 9
+ # [#24289] com_mailto Spam Email Relay
+ # [#22629] Joomla! broken on CGI web servers
+
+03-Apr-2011 Mark Dexter
+ # [#20234] security string missing on file toolbar.php
+ # [#23746] Add a system plugin event called onBeforeCompileHead
+ # [#25090] Improve .htaccess rewrite efficency
+ # [#21676] Article Manager - Select Author
+ # [#20423] Warning: realpath() [function.realpath]: Unable to access .../path.php 
+ # [#16605] PHP notice when selecting a menu type
+ # [#20536] Category Blog Layout - View Article - Editing Article - Click Images - 500 Layout "blog" not found
+
+31-Mar-2011 Mark Dexter
+ # [#22520] Articles archive years are HARDCODED!!!
+ # [#25162] *SQL installation issue with TYPE
+ # [#23053] 1.5.21 admin template params.ini error
+ # [#23135] Section blog ordering changed in 1.5.22
+ # [#16149] **PDFs not showing when icon clicked in IE...
+ # [#25024] Upgrade Geshi to 1.0.8.10
+ # [#21252] Password reset invalid token
 
 -------------------- 1.5.22 Stable Release [03-November-2010] ------------------
 
diff -aruN --binary 22/components/com_content/helpers/icon.php 23/components/com_content/helpers/icon.php
--- 22/components/com_content/helpers/icon.php	2010-04-23 12:40:12.000000000 +0200
+++ 23/components/com_content/helpers/icon.php	2011-04-04 22:52:24.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: icon.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: icon.php 21078 2011-04-04 20:52:23Z dextercowley $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -65,12 +65,13 @@
 	}
 
 	function email($article, $params, $access, $attribs = array())
-	{
+        {
+                require_once(JPATH_SITE.DS.'components'.DS.'com_mailto'.DS.'helpers'.DS.'mailto.php');
 		$uri	=& JURI::getInstance();
 		$base	= $uri->toString( array('scheme', 'host', 'port'));
-		$link	= $base.JRoute::_( ContentHelperRoute::getArticleRoute($article->slug, $article->catslug, $article->sectionid) , false );
-		$url	= 'index.php?option=com_mailto&tmpl=component&link='.base64_encode( $link );
+                $link	= $base.JRoute::_( ContentHelperRoute::getArticleRoute($article->slug, $article->catslug, $article->sectionid) , false );
 
+                $url    = 'index.php?option=com_mailto&tmpl=component&link='.MailToHelper::addLink($link);
 		$status = 'width=400,height=350,menubar=yes,resizable=yes';
 
 		if ($params->get('show_icons')) 	{
diff -aruN --binary 22/components/com_content/models/section.php 23/components/com_content/models/section.php
--- 22/components/com_content/models/section.php	2010-11-03 19:12:02.000000000 +0100
+++ 23/components/com_content/models/section.php	2011-03-31 18:01:14.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: section.php 19343 2010-11-03 18:12:02Z ian $
+ * @version		$Id: section.php 21043 2011-03-31 16:01:13Z dextercowley $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -347,7 +347,7 @@
 				JError::raiseError(500, $this->_db->stderror());
 				return false;
 			}
-			
+
 
 			// special handling required as Uncategorized content does not have a section / category id linkage
 			$i = $limitstart;
@@ -436,22 +436,30 @@
 		return $query;
 	}
 
+	/**
+	 * Build the SQL ORDER BY for the section listing.
+	 *
+	 * @param	int		$state	The published state of the articles being listed.
+	 *
+	 * @return	string	The full ORDER BY clause.
+	 * @since	1.5
+	 */
 	function _buildContentOrderBy($state = 1)
 	{
 		$filter_order		= JRequest::getCmd('filter_order');
 		$filter_order_Dir	= JRequest::getWord('filter_order_Dir');
+		$orderby			= '';
 
-		if (!in_array($filter_order, array('a.id', 'a.title', 'a.alias', 'a.title_alias', 'a.introtext', 'a.fulltext', 'a.sectionid', 'a.state',
+		if (!in_array($filter_order, array('a.id', 'a.title', 'a.alias', 'a.title_alias', 'a.sectionid', 'a.state',
 			'a.catid', 'a.created', 'a.created_by', 'a.created_by_alias', 'a.modified', 'a.modified_by', 'a.checked_out', 'a.checked_out_time',
-			'a.hits', 'a.ordering', 'a.metakey', 'a.access'))) {
-			$filter_order = 'a.ordering';
+			'a.hits', 'a.ordering', 'a.access'))) {
+			$filter_order = null;
 		}
 
 		if (!in_array(trim(strtoupper($filter_order_Dir)), array('ASC', 'DESC'))) {
 			$filter_order_Dir = 'ASC';
 		}
 
-		$orderby = ' ORDER BY ';
 		if ($filter_order) {
 			$orderby .= $filter_order .' '. $filter_order_Dir.', ';
 		}
@@ -480,7 +488,7 @@
 		}
 		$orderby .= "$primary $secondary";
 
-		return $orderby;
+		return trim($orderby) ? ' ORDER BY '.$orderby : null;
 	}
 
 	function _buildContentWhere($state = 1)
diff -aruN --binary 22/components/com_content/views/archive/view.html.php 23/components/com_content/views/archive/view.html.php
--- 22/components/com_content/views/archive/view.html.php	2010-04-23 12:40:12.000000000 +0200
+++ 23/components/com_content/views/archive/view.html.php	2011-03-31 17:54:16.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: view.html.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: view.html.php 21040 2011-03-31 15:54:16Z dextercowley $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -104,7 +104,7 @@
 		// Year Field
 		$years = array();
 		$years[] = JHTML::_('select.option',  null, JText::_( 'Year' ) );
-		for ($i=2000; $i <= 2010; $i++) {
+		for ($l = date('Y'), $i = $l - 10; $i <= $l; $i++) {
 			$years[] = JHTML::_('select.option',  $i, $i );
 		}
 		$form->yearField	= JHTML::_('select.genericlist',   $years, 'year', 'size="1" class="inputbox"', 'value', 'text', $year );
diff -aruN --binary 22/components/com_mailto/controller.php 23/components/com_mailto/controller.php
--- 22/components/com_mailto/controller.php	2010-04-23 12:40:12.000000000 +0200
+++ 23/components/com_mailto/controller.php	2011-04-04 22:52:24.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: controller.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: controller.php 21078 2011-04-04 20:52:23Z dextercowley $
  * @package		Joomla
  * @subpackage	MailTo
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -70,10 +70,10 @@
 		$MailFrom 	= $mainframe->getCfg('mailfrom');
 		$FromName 	= $mainframe->getCfg('fromname');
 
-		$link 		= base64_decode( JRequest::getVar( 'link', '', 'post', 'base64' ) );
+                $link           = MailtoHelper::validateHash(JRequest::getString('link', '', 'post'));
 
 		// Verify that this is a local link
-		if(!JURI::isInternal($link)) {
+		if((!$link) || (!JURI::isInternal($link))) {
 			//Non-local url...  
 			JError::raiseNotice( 500, JText:: _ ('EMAIL_NOT_SENT' ));
 			return $this->mailto();
diff -aruN --binary 22/components/com_mailto/helpers/mailto.php 23/components/com_mailto/helpers/mailto.php
--- 22/components/com_mailto/helpers/mailto.php	1970-01-01 01:00:00.000000000 +0100
+++ 23/components/com_mailto/helpers/mailto.php	2011-04-04 22:52:24.000000000 +0200
@@ -0,0 +1,84 @@
+<?php
+/**
+ * @version		$Id: mailto.php 21078 2011-04-04 20:52:23Z dextercowley $
+ * @package		Joomla.Site
+ * @subpackage	com_mailto
+ * @copyright	Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.
+ * @license		GNU General Public License version 2 or later; see LICENSE.txt
+ */
+
+/**
+ * @package		Joomla.Site
+ * @subpackage	com_mailto
+ */
+class MailtoHelper
+{
+	/**
+	 * Adds a URL to the mailto system and returns the hash 
+	 *
+	 * @param string url
+	 * @return URL hash
+	 */
+	function addLink($url)
+	{
+		$hash = sha1($url);
+		MailtoHelper::cleanHashes();
+		$session =& JFactory::getSession();
+		$mailto_links = $session->get('com_mailto.links', Array());
+		if(!isset($mailto_links[$hash]))
+		{
+			$mailto_links[$hash] = new stdClass();
+		}
+		$mailto_links[$hash]->link = $url;
+		$mailto_links[$hash]->expiry = time();
+		$session->set('com_mailto.links', $mailto_links);
+		return $hash;
+	}
+
+	/**
+	 * Checks if a URL is a Flash file
+	 *
+	 * @param string
+	 * @return URL
+	 */
+	function validateHash($hash)
+	{
+		$retval = false;
+		$session =& JFactory::getSession();
+		MailtoHelper::cleanHashes();
+		$mailto_links = $session->get('com_mailto.links', Array());
+		if(isset($mailto_links[$hash]))
+		{
+			$retval = $mailto_links[$hash]->link;
+		}
+		return $retval;
+	}
+
+	/**
+	 * Cleans out old hashes
+	 *
+	 * @since 1.5.23
+	 */
+	function cleanHashes($lifetime = 1440)
+	{
+		// flag for if we've cleaned on this cycle
+		static $cleaned = false;
+		if(!$cleaned)
+		{
+			$past = time() - $lifetime;
+			$session =& JFactory::getSession();
+			$mailto_links = $session->get('com_mailto.links', Array());
+			foreach($mailto_links as $index=>$link)
+			{
+				if($link->expiry < $past)
+				{
+					unset($mailto_links[$index]);
+				}
+			}
+			$cleaned = true;
+		}
+		
+		
+	}
+}
+
diff -aruN --binary 22/components/com_mailto/mailto.php 23/components/com_mailto/mailto.php
--- 22/components/com_mailto/mailto.php	2010-04-23 12:40:12.000000000 +0200
+++ 23/components/com_mailto/mailto.php	2011-04-04 22:52:24.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: mailto.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: mailto.php 21078 2011-04-04 20:52:23Z dextercowley $
  * @package		Joomla
  * @subpackage	MailTo
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -17,10 +17,11 @@
 
 jimport('joomla.application.component.helper');
 
+require_once( JPATH_COMPONENT.DS.'helpers'.DS.'mailto.php');
 require_once( JPATH_COMPONENT.DS.'controller.php' );
 
 $controller	= new MailtoController( );
 $controller->registerDefaultTask('mailto');
 $controller->execute(JRequest::getCmd('task'));
 
-//$controller->redirect();
\ No hay ningún carácter de nueva línea al final del fichero
+//$controller->redirect();
diff -aruN --binary 22/components/com_user/models/reset.php 23/components/com_user/models/reset.php
--- 22/components/com_user/models/reset.php	2010-04-23 12:40:14.000000000 +0200
+++ 23/components/com_user/models/reset.php	2011-03-31 18:11:40.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: reset.php 16385 2010-04-23 10:44:15Z ian $
+ * @version		$Id: reset.php 21046 2011-03-31 16:11:40Z dextercowley $
  * @package		Joomla
  * @subpackage	User
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -126,7 +126,7 @@
 		$row = $db->loadObject();
 
 		// Verify the token
-		if (!($row = $db->loadObject()))
+		if (!$row)
 		{
 			$this->setError(JText::_('INVALID_TOKEN'));
 			return false;
diff -aruN --binary 22/libraries/geshi/geshi/css.php 23/libraries/geshi/geshi/css.php
--- 22/libraries/geshi/geshi/css.php	2009-05-29 13:54:38.000000000 +0200
+++ 23/libraries/geshi/geshi/css.php	2011-03-31 18:09:16.000000000 +0200
@@ -1,16 +1,21 @@
 <?php
+// no direct access
+defined('_JEXEC') or die;
+
 /*************************************************************************************
  * css.php
  * -------
  * Author: Nigel McNie (nigel@geshi.org)
  * Copyright: (c) 2004 Nigel McNie (http://qbnz.com/highlighter/)
- * Release Version: 1.0.7.19
+ * Release Version: 1.0.8.10
  * Date Started: 2004/06/18
  *
  * CSS language file for GeSHi.
  *
  * CHANGES
  * -------
+ * 2008/05/23 (1.0.7.22)
+ *  -  Added description of extra language features (SF#1970248)
  * 2004/11/27 (1.0.3)
  *  -  Added support for multiple object splitters
  * 2004/10/27 (1.0.2)
@@ -47,17 +52,26 @@
  *
  ************************************************************************************/
 
-defined('GESHI_CAPS_NO_CHANGE') or die();
-
 $language_data = array (
-	'LANG_NAME' => 'CSS',
-	'COMMENT_SINGLE' => array(1 => '@'),
-	'COMMENT_MULTI' => array('/*' => '*/'),
-	'CASE_KEYWORDS' => GESHI_CAPS_NO_CHANGE,
-	'QUOTEMARKS' => array('"', "'"),
-	'ESCAPE_CHAR' => '\\',
-	'KEYWORDS' => array(
-		1 => array(
+    'LANG_NAME' => 'CSS',
+    'COMMENT_SINGLE' => array(1 => '@'),
+    'COMMENT_MULTI' => array('/*' => '*/'),
+    'COMMENT_REGEXP' => array(
+        2 => "/(?<=\\()\\s*(?:(?:[a-z0-9]+?:\\/\\/)?[a-z0-9_\\-\\.\\/:]+?)?[a-z]+?\\.[a-z]+?(\\?[^\)]+?)?\\s*?(?=\\))/i"
+        ),
+    'CASE_KEYWORDS' => GESHI_CAPS_NO_CHANGE,
+    'QUOTEMARKS' => array('"', "'"),
+    'ESCAPE_CHAR' => '',
+    'ESCAPE_REGEXP' => array(
+        //Simple Single Char Escapes
+        //1 => "#\\\\[nfrtv\$\"\n\\\\]#i",
+        //Hexadecimal Char Specs
+        2 => "#\\\\[\da-fA-F]{1,6}\s?#i",
+        //Unicode Char Specs
+        //3 => "#\\\\u[\da-fA-F]{1,8}#i",
+        ),
+    'KEYWORDS' => array(
+        1 => array(
             'aqua', 'azimuth', 'background-attachment', 'background-color',
             'background-image', 'background-position', 'background-repeat',
             'background', 'black', 'blue', 'border-bottom-color',
@@ -89,120 +103,124 @@
             'vertical-align', 'visibility', 'voice-family', 'volume',
             'white-space', 'widows', 'width', 'word-spacing', 'z-index',
             'bottom', 'left', 'height'
+            ),
+        2 => array(
+            'above', 'absolute', 'always', 'armenian', 'aural', 'auto',
+            'avoid', 'baseline', 'behind', 'below', 'bidi-override', 'blink',
+            'block', 'bold', 'bolder', 'both', 'capitalize', 'center-left',
+            'center-right', 'center', 'circle', 'cjk-ideographic',
+            'close-quote', 'collapse', 'condensed', 'continuous', 'crop',
+            'crosshair', 'cross', 'cursive', 'dashed', 'decimal-leading-zero',
+            'decimal', 'default', 'digits', 'disc', 'dotted', 'double',
+            'e-resize', 'embed', 'extra-condensed', 'extra-expanded',
+            'expanded', 'fantasy', 'far-left', 'far-right', 'faster', 'fast',
+            'fixed', 'fuchsia', 'georgian', 'gray', 'green', 'groove',
+            'hebrew', 'help', 'hidden', 'hide', 'higher', 'high',
+            'hiragana-iroha', 'hiragana', 'icon', 'inherit', 'inline-table',
+            'inline', 'inset', 'inside', 'invert', 'italic', 'justify',
+            'katakana-iroha', 'katakana', 'landscape', 'larger', 'large',
+            'left-side', 'leftwards', 'level', 'lighter', 'lime',
+            'line-through', 'list-item', 'loud', 'lower-alpha', 'lower-greek',
+            'lower-roman', 'lowercase', 'ltr', 'lower', 'low', 'maroon',
+            'medium', 'message-box', 'middle', 'mix', 'monospace', 'n-resize',
+            'narrower', 'navy', 'ne-resize', 'no-close-quote',
+            'no-open-quote', 'no-repeat', 'none', 'normal', 'nowrap',
+            'nw-resize', 'oblique', 'olive', 'once', 'open-quote', 'outset',
+            'outside', 'overline', 'pointer', 'portrait', 'purple', 'px',
+            'red', 'relative', 'repeat-x', 'repeat-y', 'repeat', 'rgb',
+            'ridge', 'right-side', 'rightwards', 's-resize', 'sans-serif',
+            'scroll', 'se-resize', 'semi-condensed', 'semi-expanded',
+            'separate', 'serif', 'show', 'silent', 'silver', 'slow', 'slower',
+            'small-caps', 'small-caption', 'smaller', 'soft', 'solid',
+            'spell-out', 'square', 'static', 'status-bar', 'super',
+            'sw-resize', 'table-caption', 'table-cell', 'table-column',
+            'table-column-group', 'table-footer-group', 'table-header-group',
+            'table-row', 'table-row-group', 'teal', 'text', 'text-bottom',
+            'text-top', 'thick', 'thin', 'transparent', 'ultra-condensed',
+            'ultra-expanded', 'underline', 'upper-alpha', 'upper-latin',
+            'upper-roman', 'uppercase', 'url', 'visible', 'w-resize', 'wait',
+            'white', 'wider', 'x-fast', 'x-high', 'x-large', 'x-loud',
+            'x-low', 'x-small', 'x-soft', 'xx-large', 'xx-small', 'yellow',
+            'yes'
+            )
+        ),
+    'SYMBOLS' => array(
+        '(', ')', '{', '}', ':', ';',
+        '>', '+', '*', ',', '^', '='
+        ),
+    'CASE_SENSITIVE' => array(
+        GESHI_COMMENTS => false,
+        1 => true,
+        2 => true
         ),
-		2 => array(
-             'above', 'absolute', 'always', 'armenian', 'aural', 'auto',
-             'avoid', 'baseline', 'behind', 'below', 'bidi-override', 'blink',
-             'block', 'bold', 'bolder', 'both', 'capitalize', 'center-left',
-             'center-right', 'center', 'circle', 'cjk-ideographic',
-             'close-quote', 'collapse', 'condensed', 'continuous', 'crop',
-             'crosshair', 'cross', 'cursive', 'dashed', 'decimal-leading-zero',
-             'decimal', 'default', 'digits', 'disc', 'dotted', 'double',
-             'e-resize', 'embed', 'extra-condensed', 'extra-expanded',
-             'expanded', 'fantasy', 'far-left', 'far-right', 'faster', 'fast',
-             'fixed', 'fuchsia', 'georgian', 'gray', 'green', 'groove',
-             'hebrew', 'help', 'hidden', 'hide', 'higher', 'high',
-             'hiragana-iroha', 'hiragana', 'icon', 'inherit', 'inline-table',
-             'inline', 'inset', 'inside', 'invert', 'italic', 'justify',
-             'katakana-iroha', 'katakana', 'landscape', 'larger', 'large',
-             'left-side', 'leftwards', 'level', 'lighter', 'lime',
-             'line-through', 'list-item', 'loud', 'lower-alpha', 'lower-greek',
-             'lower-roman', 'lowercase', 'ltr', 'lower', 'low', 'maroon',
-             'medium', 'message-box', 'middle', 'mix', 'monospace', 'n-resize',
-             'narrower', 'navy', 'ne-resize', 'no-close-quote',
-             'no-open-quote', 'no-repeat', 'none', 'normal', 'nowrap',
-             'nw-resize', 'oblique', 'olive', 'once', 'open-quote', 'outset',
-             'outside', 'overline', 'pointer', 'portrait', 'purple', 'px',
-             'red', 'relative', 'repeat-x', 'repeat-y', 'repeat', 'rgb',
-             'ridge', 'right-side', 'rightwards', 's-resize', 'sans-serif',
-             'scroll', 'se-resize', 'semi-condensed', 'semi-expanded',
-             'separate', 'serif', 'show', 'silent', 'silver', 'slow', 'slower',
-             'small-caps', 'small-caption', 'smaller', 'soft', 'solid',
-             'spell-out', 'square', 'static', 'status-bar', 'super',
-             'sw-resize', 'table-caption', 'table-cell', 'table-column',
-             'table-column-group', 'table-footer-group', 'table-header-group',
-             'table-row', 'table-row-group', 'teal', 'text', 'text-bottom',
-             'text-top', 'thick', 'thin', 'transparent', 'ultra-condensed',
-             'ultra-expanded', 'underline', 'upper-alpha', 'upper-latin',
-             'upper-roman', 'uppercase', 'url', 'visible', 'w-resize', 'wait',
-             'white', 'wider', 'x-fast', 'x-high', 'x-large', 'x-loud',
-             'x-low', 'x-small', 'x-soft', 'xx-large', 'xx-small', 'yellow',
-             'yes'
+    'STYLES' => array(
+        'KEYWORDS' => array(
+            1 => 'color: #000000; font-weight: bold;',
+            2 => 'color: #993333;'
+            ),
+        'COMMENTS' => array(
+            1 => 'color: #a1a100;',
+            2 => 'color: #ff0000; font-style: italic;',
+            'MULTI' => 'color: #808080; font-style: italic;'
+            ),
+        'ESCAPE_CHAR' => array(
+            0 => 'color: #000099; font-weight: bold;',
+            //1 => 'color: #000099; font-weight: bold;',
+            2 => 'color: #000099; font-weight: bold;'
+            //3 => 'color: #000099; font-weight: bold;'
+            ),
+        'BRACKETS' => array(
+            0 => 'color: #00AA00;'
+            ),
+        'STRINGS' => array(
+            0 => 'color: #ff0000;'
+            ),
+        'NUMBERS' => array(
+            0 => 'color: #cc66cc;'
+            ),
+        'METHODS' => array(
+            ),
+        'SYMBOLS' => array(
+            0 => 'color: #00AA00;'
+            ),
+        'SCRIPT' => array(
+            ),
+        'REGEXPS' => array(
+            0 => 'color: #cc00cc;',
+            1 => 'color: #6666ff;',
+            2 => 'color: #3333ff;',
+            3 => 'color: #933;'
             )
         ),
-	'SYMBOLS' => array(
-		'(', ')', '{', '}', ':', ';'
-		),
-	'CASE_SENSITIVE' => array(
-		GESHI_COMMENTS => false,
-		1 => true,
-		2 => true
-		),
-	'STYLES' => array(
-		'KEYWORDS' => array(
-			1 => 'color: #000000; font-weight: bold;',
-			2 => 'color: #993333;'
-			),
-		'COMMENTS' => array(
-			1 => 'color: #a1a100;',
-			'MULTI' => 'color: #808080; font-style: italic;'
-			),
-		'ESCAPE_CHAR' => array(
-			0 => 'color: #000099; font-weight: bold;'
-			),
-		'BRACKETS' => array(
-			0 => 'color: #66cc66;'
-			),
-		'STRINGS' => array(
-			0 => 'color: #ff0000;'
-			),
-		'NUMBERS' => array(
-			0 => 'color: #cc66cc;'
-			),
-		'METHODS' => array(
-			),
-		'SYMBOLS' => array(
-			0 => 'color: #66cc66;'
-			),
-		'SCRIPT' => array(
-			),
-		'REGEXPS' => array(
-			0 => 'color: #cc00cc;',
-			1 => 'color: #6666ff;',
-			2 => 'color: #3333ff;',
-            3 => 'color: #933;',
-            4 => 'color: #933;',
-			)
-		),
-	'URLS' => array(
-		1 => '',
-		2 => ''
-		),
-	'OOLANG' => false,
-	'OBJECT_SPLITTERS' => array(
-		),
-	'REGEXPS' => array(
-		0 => '\#[a-zA-Z0-9\-_]+',
-		1 => '\.[a-zA-Z0-9\-_]+',
-        2 => ':[a-zA-Z0-9\-]+',
-        3 => '(\d+|(\d*\.\d+))(em|ex|pt|px|cm|in|%)',
-        4 => array(
-            GESHI_SEARCH    => '(url\()([^)]+)(\))',
-            GESHI_REPLACE   => '\\2',
-            GESHI_BEFORE    => '\\1',
-            GESHI_AFTER     => '\\3',
-            GESHI_MODIFIERS => 'si'
+    'URLS' => array(
+        1 => '',
+        2 => ''
+        ),
+    'OOLANG' => false,
+    'OBJECT_SPLITTERS' => array(
+        ),
+    'REGEXPS' => array(
+        //DOM Node ID
+        0 => '\#[a-zA-Z0-9\-_]+(?:\\\\:[a-zA-Z0-9\-_]+)*',
+        //CSS classname
+        1 => '\.(?!\d)[a-zA-Z0-9\-_]+(?:\\\\:[a-zA-Z0-9\-_]+)*\b(?=[\{\.#\s,:].|<\|)',
+        //CSS Pseudo classes
+        //note: & is needed for &gt; (i.e. > )
+        2 => '(?<!\\\\):(?!\d)[a-zA-Z0-9\-]+\b(?:\s*(?=[\{\.#a-zA-Z,:+*&](.|\n)|<\|))',
+        //Measurements
+        3 => '[+\-]?(\d+|(\d*\.\d+))(em|ex|pt|px|cm|in|%)',
+        ),
+    'STRICT_MODE_APPLIES' => GESHI_NEVER,
+    'SCRIPT_DELIMITERS' => array(
+        ),
+    'HIGHLIGHT_STRICT_BLOCK' => array(
+        ),
+    'TAB_WIDTH' => 4,
+    'PARSER_CONTROL' => array(
+        'KEYWORDS' => array(
+            'DISALLOWED_AFTER' => '(?![a-zA-Z0-9_\|%\\-&\.])'
         )
-		),
-	'STRICT_MODE_APPLIES' => GESHI_NEVER,
-	'SCRIPT_DELIMITERS' => array(
-		),
-	'HIGHLIGHT_STRICT_BLOCK' => array(
-		)
+    )
 );
 
-if (isset($this) && is_a($this, 'GeSHi')) {
-    $language_data['STYLES']['NUMBERS'][0] = $language_data['STYLES']['REGEXPS'][3];
-}
-
-?>
+?>
\ No hay ningún carácter de nueva línea al final del fichero
